public class Term implements ITerm {
    private String term;

    // precedence of words, higher weight means the word should be suggested first
    // before another word given the same prefix
    private long weight;

    public Term(String term, long weight) {
        if (term == null || weight < 0) {
            throw new IllegalArgumentException();
        }
        this.term = term;
        this.weight = weight;
    }

    public String getTerm() {
        return this.term;
    }

    public void setTerm(String term) {
        this.term = term;
    }

    public long getWeight() {
        return this.weight;
    }

    public void setWeight(long weight) {
        this.weight = weight;
    }

    @Override
    public int compareTo(ITerm that) {
        return this.term.compareTo(((Term) that).term);
    }

    @Override
    public String toString() {
        return Long.toString(weight) + "\t" + term;
    }
}
